<?php

class tx_restrictfe {

    public $extKey = 'restrictfe';


    /**
     * This is hook that is called at the very beginning of the FE rendering process
     *
     * @param $_params
     * @param $pObj
     *
     * @return void
     */
    function redirectCheckForLoggedBeUser($_params, &$pObj) {

        if ($GLOBALS['TYPO3_CONF_VARS']['EXTCONF'][$this->extKey]['enable']) {

            if (!$pObj->beUserLogin) {

                $restrictfeforbe_EmConf = @unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf'][$this->extKey]);

                $GLOBALS['LANG'] = t3lib_div::makeInstance('language');
                $GLOBALS['LANG']->init('default');
                $GLOBALS['LANG']->includeLLFile('EXT:' . $this->extKey . '/Resources/Private/Language/locallang_fe.xml');

                $beLoginLink = t3lib_div::getIndpEnv('TYPO3_SITE_URL') . 'typo3/index.php?redirect_url=' . t3lib_div::getIndpEnv('TYPO3_REQUEST_URL');

                switch ($restrictfeforbe_EmConf['actionIfAccessForbiden']) {

                    case 'redirectToDomain':
                        if (trim($restrictfeforbe_EmConf['redirectToDomainDomain'])) {
                            $redirectUrl = 'http://' . trim($restrictfeforbe_EmConf['redirectToDomainDomain']);
                            t3lib_utility_Http::redirect($redirectUrl, $httpStatus = t3lib_utility_Http::HTTP_STATUS_307);
                        } else {
                            echo $GLOBALS['LANG']->getLL('noDomainFoundInEM');
                            exit;
                        }
                        exit;

                    case '404pageNotFound':
                        $templateCode = file_get_contents(t3lib_extMgm::extPath($this->extKey, '/Resources/Private/Templates/actionIfAccessForbiden_notFound.tmpl'));
                        $this->getNoCacheHeaders();
                        $this->getNoIndexHeaders();
                        header("HTTP/1.0 404 Not Found");
                        echo($templateCode);

                        exit;

                    // this will show the be login directly
                    case 'showBeLogin':
                        $this->getNoCacheHeaders();
                        $this->getNoIndexHeaders();
                        header("HTTP/1.0 403 Access Forbidden");
                        header('Location: ' . $beLoginLink);

                        exit;

                    default:
                        $templateCode = file_get_contents(t3lib_extMgm::extPath($this->extKey, '/Resources/Private/Templates/actionIfAccessForbiden_showBeLoginLink.tmpl'));
                        $markers = array(
                            'LINK_TO_LOGIN' => $beLoginLink,
                        );

                        $content = t3lib_parsehtml::substituteMarkerArray($templateCode, $markers, '###|###');

                        $this->getNoCacheHeaders();
                        $this->getNoIndexHeaders();
                        header("HTTP/1.0 403 Access Forbidden");
                        echo $content;

                        exit;

                }
            }
        }
    }

    function getNoCacheHeaders() {
        header('Content-Type: text/html; charset=utf-8');
        header("Expires: Sat, 26 Jul 1997 05:00:00 GMT");
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
        header('Cache-Control: no-store, no-cache, must-revalidate'); // HTTP/1.1
        header('Cache-Control: pre-check=0, post-check=0, max-age=0'); // HTTP/1.1
        header("Pragma: no-cache");
        header("Expires: 0");
    }

    function getNoIndexHeaders() {
        header('X-Robots-Tag: noindex,nofollow');
    }

}